## cppzmq 4.8.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.11)

list (APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

include (DetectCPPZMQVersion)

project(cppzmq VERSION ${DETECTED_CPPZMQ_VERSION})

if (NOT TARGET libzmq AND NOT TARGET libzmq-static)
  find_package(ZeroMQ QUIET)

  # libzmq autotools install: fallback to pkg-config
  if(NOT ZeroMQ_FOUND)
    message(STATUS "CMake libzmq package not found, trying again with pkg-config (normal install of zeromq)")
    list (APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_LIST_DIR}/libzmq-pkg-config)
    find_package(ZeroMQ REQUIRED)
  endif()

  # TODO "REQUIRED" above should already cause a fatal failure if not found, but this doesn't seem to work
  if(NOT ZeroMQ_FOUND)
    message(FATAL_ERROR "ZeroMQ was not found, neither as a CMake package nor via pkg-config")
  endif()

  if (ZeroMQ_FOUND AND NOT (TARGET libzmq OR TARGET libzmq-static))
    message(FATAL_ERROR "ZeroMQ version not supported!")
  endif()
endif()

if (EXISTS "${CMAKE_SOURCE_DIR}/.git")
    OPTION (ENABLE_DRAFTS "Build and install draft classes and methods" ON)
else ()
    OPTION (ENABLE_DRAFTS "Build and install draft classes and methods" OFF)
endif ()
if (ENABLE_DRAFTS)
    ADD_DEFINITIONS (-DZMQ_BUILD_DRAFT_API)
    set (pkg_config_defines "-DZMQ_BUILD_DRAFT_API=1")
else (ENABLE_DRAFTS)
    set (pkg_config_defines "")
endif (ENABLE_DRAFTS)

message(STATUS "cppzmq v${cppzmq_VERSION}")

set(CPPZMQ_HEADERS
    zmq.hpp
    zmq_addon.hpp
)

foreach (target cppzmq cppzmq-static)
  add_library(${target} INTERFACE)
  target_include_directories(${target} INTERFACE $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
                                                 $<INSTALL_INTERFACE:include>)
endforeach()

target_link_libraries(cppzmq INTERFACE libzmq)
target_link_libraries(cppzmq-static INTERFACE libzmq-static)

include(GNUInstallDirs)
include(CMakePackageConfigHelpers)

install(TARGETS cppzmq cppzmq-static
        EXPORT ${PROJECT_NAME}-targets)

install(FILES ${CPPZMQ_HEADERS}
        DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})

# GNUInstallDirs "DATADIR" wrong here; CMake search path wants "share".
set(CPPZMQ_CMAKECONFIG_INSTALL_DIR "share/cmake/${PROJECT_NAME}" CACHE STRING "install path for cppzmqConfig.cmake")

configure_file(libzmq-pkg-config/FindZeroMQ.cmake
               libzmq-pkg-config/FindZeroMQ.cmake
               COPYONLY)

export(EXPORT ${PROJECT_NAME}-targets
     FILE "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}Targets.cmake")
configure_package_config_file(${PROJECT_NAME}Config.cmake.in
                              "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}Config.cmake"
                              INSTALL_DESTINATION ${CPPZMQ_CMAKECONFIG_INSTALL_DIR})
# Workaround until ARCH_INDEPENDENT flag can be used with cmake 3.14.
# The ConigVersion.cmake file contains checks for the architecture is was
# generated on, which can cause problems for header only libraries
# used with e.g. the Conan package manager. Since it is header only we
# can/should omit those checks.
set(CPPZMQ_SIZEOF_VOID_P ${CMAKE_SIZEOF_VOID_P})
set(CMAKE_SIZEOF_VOID_P "") # a simple unset is not sufficient
write_basic_package_version_file(${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}ConfigVersion.cmake
                                 VERSION ${CPPZMQ_VERSION}
                                 COMPATIBILITY AnyNewerVersion)
set(CMAKE_SIZEOF_VOID_P ${CPPZMQ_SIZEOF_VOID_P})

install(EXPORT ${PROJECT_NAME}-targets
        FILE ${PROJECT_NAME}Targets.cmake
        DESTINATION ${CPPZMQ_CMAKECONFIG_INSTALL_DIR})
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}Config.cmake
              ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}ConfigVersion.cmake
              DESTINATION ${CPPZMQ_CMAKECONFIG_INSTALL_DIR})
install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/libzmq-pkg-config/FindZeroMQ.cmake
              DESTINATION ${CPPZMQ_CMAKECONFIG_INSTALL_DIR}/libzmq-pkg-config)

option(CPPZMQ_BUILD_TESTS "Whether or not to build the tests" ON)

if (CPPZMQ_BUILD_TESTS)
    enable_testing()
    add_subdirectory(tests)
    if (CMAKE_CXX_STANDARD AND NOT CMAKE_CXX_STANDARD EQUAL 98 AND CMAKE_CXX_STANDARD GREATER_EQUAL 11)
        add_subdirectory(examples)
    endif()
endif()

=== tests/CMakeLists.txt ===
find_package(Threads)

find_package(Catch2 QUIET)

if (NOT Catch2_FOUND)
  include(FetchContent)

  FetchContent_Declare(
    Catch2
    GIT_REPOSITORY https://github.com/catchorg/Catch2.git
    GIT_TAG        v2.13.4)

  FetchContent_MakeAvailable(Catch2)

  list(APPEND CMAKE_MODULE_PATH ${catch2_SOURCE_DIR}/contrib)
endif()

add_executable(
    unit_tests
    buffer.cpp
    message.cpp
    context.cpp
    socket.cpp
    socket_ref.cpp
    poller.cpp
    active_poller.cpp
    multipart.cpp
    recv_multipart.cpp
    send_multipart.cpp
    codec_multipart.cpp
    monitor.cpp
    utilities.cpp
)

target_include_directories(unit_tests PUBLIC ${CATCH_MODULE_PATH})
target_link_libraries(
    unit_tests
    PRIVATE Catch2::Catch2
    PRIVATE cppzmq
    PRIVATE ${CMAKE_THREAD_LIBS_INIT}
)

OPTION (COVERAGE "Enable gcda file generation needed by lcov" OFF)

if (COVERAGE)
    target_compile_options(unit_tests PRIVATE --coverage)
    target_link_options(unit_tests PRIVATE --coverage)
    message(STATUS "Coverage enabled")
endif()

include(CTest)
include(Catch)
catch_discover_tests(unit_tests)

=== debian/changelog ===
cppzmq (4.8.1-3) unstable; urgency=medium

  * fix missing Replaces (Closes: #1017594)

 -- Stephan Lachnit <stephanlachnit@debian.org>  Thu, 18 Aug 2022 13:22:14 +0200

cppzmq (4.8.1-2) unstable; urgency=medium

  * fix autopkgtest
  * mark as Multi-Arch: no due to conflicting CMake files

 -- Stephan Lachnit <stephanlachnit@debian.org>  Tue, 16 Aug 2022 09:35:00 +0200

cppzmq (4.8.1-1) unstable; urgency=medium

  [ Gordon Ball ]
  * Initial packaging

  [ Stephan Lachnit ]
  * Initial release (Closes: #1016347)

 -- Stephan Lachnit <stephanlachnit@debian.org>  Fri, 29 Jul 2022 21:52:26 +0200

=== debian/control ===
Source: cppzmq
Priority: optional
Section: libs
Maintainer: Stephan Lachnit <stephanlachnit@debian.org>
Build-Depends: debhelper-compat (= 13),
               cmake,
               libzmq3-dev,
               pkg-config,
Rules-Requires-Root: no
Standards-Version: 4.6.1
Homepage: https://github.com/zeromq/cppzmq
Vcs-Git: https://salsa.debian.org/debian/cppzmq.git
Vcs-Browser: https://salsa.debian.org/debian/cppzmq

Package: cppzmq-dev
Section: libdevel
Architecture: any
Multi-Arch: no
Depends: ${misc:Depends}, libzmq3-dev
Breaks: libzmq3-dev (<< 4.3.4-3)
Replaces: libzmq3-dev (<< 4.3.4-3)
Description: C++ bindings for libzmq (headers)
 cppzmq is a header-only C++ binding for libzmq, which tries to provide
 a type-safe, exception handled and resource managed view of libzmq.

## cppzmq 4.9.0

=== debian/changelog ===
cppzmq (4.9.0-1) unstable; urgency=medium

  [ Debian Janitor ]
  * Apply multi-arch hints. + cppzmq-dev: Add Multi-Arch: same.

  [ Stephan Lachnit ]
  * New upstream version 4.9.0

 -- Stephan Lachnit <stephanlachnit@debian.org>  Wed, 09 Nov 2022 21:51:01 +0100

=== debian/control ===
--- 
+++ 
@@ -15,7 +15,7 @@
 Package: cppzmq-dev
 Section: libdevel
 Architecture: any
-Multi-Arch: no
+Multi-Arch: same
 Depends: ${misc:Depends}, libzmq3-dev
 Breaks: libzmq3-dev (<< 4.3.4-3)
 Replaces: libzmq3-dev (<< 4.3.4-3)

## cppzmq 4.10.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -87,6 +87,11 @@
                                  COMPATIBILITY AnyNewerVersion)
 set(CMAKE_SIZEOF_VOID_P ${CPPZMQ_SIZEOF_VOID_P})
 
+configure_file(${CMAKE_CURRENT_SOURCE_DIR}/cppzmq.pc.in
+               ${CMAKE_CURRENT_BINARY_DIR}/cppzmq.pc @ONLY)
+install(FILES ${CMAKE_CURRENT_BINARY_DIR}/cppzmq.pc
+              DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)
+
 install(EXPORT ${PROJECT_NAME}-targets
         FILE ${PROJECT_NAME}Targets.cmake
         DESTINATION ${CPPZMQ_CMAKECONFIG_INSTALL_DIR})

=== debian/changelog ===
cppzmq (4.10.0-1build1) noble; urgency=high

  * No change rebuild against frame pointers and time_t.

 -- Julian Andres Klode <juliank@ubuntu.com>  Mon, 22 Apr 2024 13:10:31 +0200

cppzmq (4.10.0-1) unstable; urgency=medium

  * New upstream version 4.10.0
  * Update Standards-Version to 4.6.2, no changes needed
  * Add patch to bump minimum CMake version (Closes: #1040723)

 -- Stephan Lachnit <stephanlachnit@debian.org>  Thu, 20 Jul 2023 23:19:41 +0200

=== debian/control ===
--- 
+++ 
@@ -1,13 +1,14 @@
 Source: cppzmq
 Priority: optional
 Section: libs
-Maintainer: Stephan Lachnit <stephanlachnit@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Stephan Lachnit <stephanlachnit@debian.org>
 Build-Depends: debhelper-compat (= 13),
                cmake,
                libzmq3-dev,
                pkg-config,
 Rules-Requires-Root: no
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Homepage: https://github.com/zeromq/cppzmq
 Vcs-Git: https://salsa.debian.org/debian/cppzmq.git
 Vcs-Browser: https://salsa.debian.org/debian/cppzmq

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DCPPZMQ_BUILD_TESTS=OFF

=== debian/watch ===
version=4
https://github.com/zeromq/cppzmq/tags (?:.*?/)?v?@ANY_VERSION@@ARCHIVE_EXT@
